
LSUpgradeRefreshEvent = {};
LSUpgradeRefreshEvent_mt = Class(LSUpgradeRefreshEvent, Event);
InitEventClass(LSUpgradeRefreshEvent, "LSUpgradeRefreshEvent");

function LSUpgradeRefreshEvent:emptyNew()
	local self = Event:new(LSUpgradeRefreshEvent_mt);
	return self;
end;

function LSUpgradeRefreshEvent:new(vehicle)

	local self = LSUpgradeRefreshEvent:emptyNew();
	self.vehicle = vehicle;
  
	return self;
end;

function LSUpgradeRefreshEvent:readStream(streamId, connection)

	local anzahl = streamReadInt32(streamId)

	local id = streamReadInt32(streamId)
	self.vehicle = networkGetObject(id);
	
	for i=1, anzahl do

		self.name = streamReadString(streamId);

		for _, upgrade in pairs (self.vehicle.upgrades) do
			
			if upgrade.name == self.name then
			
				self.level = upgrade.level;
				break;
			end;
		end;
		
		self:run(connection);
	end;
 
	
end;

function LSUpgradeRefreshEvent:writeStream(streamId, connection)

	streamWriteInt32(streamId, #self.vehicle.upgrades);

	local id = networkGetObjectId(self.vehicle)
	streamWriteInt32(streamId, id);
	
	for _, upgrade in pairs (self.vehicle.upgrades) do
	
		streamWriteString(streamId, upgrade.name);
	end;
end;

function LSUpgradeRefreshEvent:run(connection)

	if not connection:getIsServer() then
		g_client:getServerConnection():sendEvent(LSUpgradeEvent:new(self.vehicle, self.name, self.level))
	end;
end;